/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.towerrun.game;

import de.steamwar.towerrun.TowerRun;
import de.steamwar.towerrun.config.WorldConfig;
import org.bukkit.entity.Player;
import org.bukkit.util.Vector;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

public record TowerRunPlayer(Player player) {
    private static final Map<Player, TowerRunPlayer> players = new HashMap<>();

    public static TowerRunPlayer get(Player player) {
        return players.computeIfAbsent(player, TowerRunPlayer::new);
    }

    public static void remove(Player player) {
        players.remove(player);
    }

    public static Collection<TowerRunPlayer> getAll() {
        return players.values();
    }

    public void reset() {
        player.getInventory().clear();
        player.updateInventory();
        player.setHealth(20);
        if (TowerRun.getTowerGenerator() != null) {
            player.teleport(TowerRun.getTowerGenerator().getSpawn());
        } else {
            player.teleport(WorldConfig.SPAWN);
        }
        player.setVelocity(new Vector(0, 0, 0));
    }

    @Override
    public String toString() {
        return "TowerRunPlayer{" +
                "player=" + player.getName() +
                '}';
    }
}
